//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  PaleVioletRed
#property indicator_color2  LimeGreen
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern int HalfLength1 = 25;
extern int HalfLength2 = 13;
extern int Price      = PRICE_CLOSE;

double buffer1[];
double buffer2[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   IndicatorDigits(10);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   return(0);
}
int deinit() { return(0); }




//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][10];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars+MathMax(HalfLength1,HalfLength2),Bars-1);
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)  work[r][0] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][1] = iCTma(0,HalfLength1,i);
      work[r][2] = iCTma(0,HalfLength2,i);
      work[r][3] = work[r][1]-work[r][2];
   }
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][4] = iCTma(3,HalfLength2,i);
      work[r][5] = work[r][4]-work[r-1][4];
   }
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][6] = iCTma(5,HalfLength2,i);
      work[r][7] = work[r][6]-work[r-1][6];
   }
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][8] = iCTma(7,HalfLength2,i);
      work[r][9] = work[r][8]-work[r-1][8];
         buffer1[i] = work[r][8];
         buffer2[i] = work[r][9];
   }
   return(0);
}

//
//
//
//
//

double iCTma(int useValue, int halfLength, int i)
{
   i = Bars-i-1;
   
   //
   //
   //
   //
   //
      
   double sum  = work[i][useValue];
   double sumw = 1;
 
      //
      //
      //
      //
      //
      
      for(int j=1; j<=halfLength; j++)
      {
         sum  += work[i-j][useValue];
         sumw += 1;
         if ((i+j)<Bars)
         {
            sum  += work[i+j][useValue];
            sumw += 1;
         }
      }
   return(sum/sumw);      
}